/**
 * Memory Analyser  version 1.00
 * Copyright (c) 2018, Tycho Veltmeijer.
 * All rights reserved.
**/

/*This code creates a list, if more item will be added the list will be doubled in size.*/

#include <stdio.h>
#include "list.h"

#include <string.h>
#include <time.h>
#include <Psapi.h>

/*Create list*/
void* createList() {
	void* list;
	void* listp;

	listp = (void*) malloc(sizeof(void*));

	list = (void*) malloc(sizeof(void*)*100);
	*(int*)list = ( (sizeof(void*)*100) - (sizeof(int) * 2)) / sizeof(void*);
	*((int*)list+1) = 0;
	*(void**)listp = list;

	return listp;
}

void addToList(void* list, void* value) {
	int* listOptions;
	void* list2;

	void* newList;
	int* newListInt;

	listOptions = (int*) *(void**) list;
	list2 = (void**) (listOptions+2);

	/*resize list*/
	if(*listOptions == *(listOptions+1)) {
		newList = malloc(((*listOptions) * 2 * sizeof(void*)) + (sizeof(int) * 2));
		newListInt = (int*) newList;

		/*copy the old list*/
		*newListInt = (*listOptions) * 2;
		*(newListInt+1) = *(listOptions+1);
		memcpy(newListInt+2, list2, *(listOptions+1) * sizeof(void*));

		/*release old list*/
		free(*(void**)list);
		*(void**)list = newList;
		
		listOptions = (int*) *(void**) list;
		list2 = (void**) (listOptions+2);
	}

	* ( (void**)list2 + *(listOptions+1)) = value;
	*(listOptions+1) += 1;
}

/*get item x from list*/
void* getFromList(void* list, int id) {
	int* listOptions;
	void* list2;

	listOptions = (int*) *(void**) list;
	list2 = (void**) (listOptions+2);

	if(*(listOptions+1)<id-1)
		return 0;

	return * ( (void**)list2 + id);
}

/*count items on list.*/
int countList(void* list) {
	int* listOptions;

	listOptions = (int*) *(void**) list;

	return *(listOptions+1);
}

void freeList(void* list) {
	free(*(void**) list);
	free(list);
}